/* CoolTran, traductor de trminos.
 * 
 * Copyright (C) 2007
 *
 * Authors: Javier Garca Palacios <jgarcia1709@gmail.com>
 *          Diego Sevillano de Miguel <sevas85@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
 */

import java.io.File;

import java.io.IOException;
import java.io.PrintStream;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.ArrayList;


public class Busqueda {

	String Palabra = ""; 
	String tipoDic = "";
	String diccionarioColaborativoSeleccionado = "";
    int numeroPalabras = 0;
    ArrayList<String> numTermino = null;
    boolean flagHayTraduccion1=false;
    boolean flagHayTraduccion2=false;
	
	
	public  Busqueda() {
		
	}
	
	public  String[] traducirLocal(String termino){
		
		tipoDic="Local";
		Palabra = termino;
		
		String fichero[]=null;
		fichero =new String[2];
		
		fichero[1]="Local";
		fichero[0]=Configuracion.traduc.getProperty(Palabra);
		if(Configuracion.traduc.getProperty(Palabra)==null){
			 //cambiar por mensaje en idiomas
			fichero[0]=(Configuracion.messages.getString("noencontrado_local1")+"\n\n"+Configuracion.messages.getString("noencontrado_local2"));
		}
		
		return fichero;
	}
	
	public String[] traducirColaborativo(String termino,String dicColabSeleccionado,Conexion conexion){
		
		tipoDic="Colaborativo";
		diccionarioColaborativoSeleccionado = dicColabSeleccionado;
		Palabra = termino;
		
		Connection con = null;
		String traduccion="";
		String fichero[]=null;
		String query="";
		Statement stmt = null;
		ResultSet res = null;
		String fecha="";

		
		int longitud = Palabra.length() + 2 ;

	    PrintStream ps = null;
	    fichero =new String[2];

			
			fichero[1]="Colaborativo";
		    try {
		    	SimpleDateFormat formato1 = new SimpleDateFormat("yyyyMMddHHmmss");
		    	fecha = formato1.format(System.currentTimeMillis());
		    	fichero[0]="traduc"+fecha+".html";
		    	  	
		    	File file =  new File(fichero[0]);
		    	 ps = new PrintStream(file);
		    	 ps.println("<html><body><table border=\"0\"  width=\"260\"><tr><td width=\"260\">");
		    	 
		    	 //Primero mostramos el resultado literal
		    	 
		    	query= "select d.traduccion, d.termino , t.descripcion ,d.num from `"+diccionarioColaborativoSeleccionado+"` d  , `TIPO-PALABRA` t where d.termino like '"+Palabra+"' " +
		    		   "  and (t.tipo = d.tipo)    " +
		    		   " and NOT EXISTS ( select * from   `valorar` v where v.numtermino = d.num and v.tabla= '"+diccionarioColaborativoSeleccionado+"' and " +
		    		   " valido = 1) " ;
					
					con = conexion.con;
					try {
						stmt = con.createStatement();
						res = (ResultSet) stmt.executeQuery(query);
						numeroPalabras = 1;
						numTermino = new ArrayList<String>();
						
						while (res.next()){
							flagHayTraduccion1=true;
							
							ps.println("<b><font size=\"4\" color=\"BLUE\">");
							traduccion = res.getString(2);
							ps.println(numeroPalabras+". "+traduccion);
							ps.println(" :");
							ps.println("</font></b>");
							
							ps.println("<font size=\"3\" color=\"RED\">");
							ps.println(res.getString(3));
							ps.println("</font>");
		
							ps.println("<font size=\"4\" color=\"BLACK\">");
							traduccion = res.getString(1);			
							ps.println(traduccion);
							ps.println("</font>");
							ps.println("<br>");
							//System.out.println("Terminos:"+ res.getString(4));
							numTermino.add(res.getString(4));
							numeroPalabras++;						
						}				

						
				    	 //Las posibles coincidencias
					    	 
						query= "select d.traduccion, SUBSTR(d.termino,"+longitud+"),  t.descripcion from `"+diccionarioColaborativoSeleccionado+"` d, `TIPO-PALABRA` t where d.termino like '"+Palabra+" %' "+
						 	   " and (t.tipo = d.tipo)   " +
							   " and NOT EXISTS ( select * from   `valorar` v where v.numtermino = d.num and v.tabla= '"+diccionarioColaborativoSeleccionado+"' and " +
						 	   " valido = 1) " ;
					
						
						//System.out.println("La query es "+query);
						
						con = conexion.con;
						 
						stmt = con.createStatement(); 
						res = (ResultSet) stmt.executeQuery(query);
						
						
						
						
						while (res.next()){
							flagHayTraduccion2=true;
							
							ps.println("<b><font size=\"4\" color=\"#800000\">");
							traduccion = res.getString(2);
							ps.println("~ ");
							ps.println(traduccion);
							ps.println(" :");
							ps.println("</font></b>");
							
							ps.println("<font size=\"3\" color=\"RED\">");
							ps.println(res.getString(3));
							ps.println("</font>");
							
							ps.println("<font size=\"4\" color=\"BLACK\">");
							traduccion = res.getString(1);			
							ps.println(traduccion);
							ps.println("</font><br>");
							//traduccion = traduccion + res.getString(2)  + "\n\t "+ res.getString(1);
					
						
						}
						
						 //cambiar por mensaje en idiomas
						if (!flagHayTraduccion1 && !flagHayTraduccion2){ //si no ha encontrado el termino en la base de datos
							ps.println("<b><font size=\"4\" color=\"BLACK\">");
							ps.println(Configuracion.messages.getString("noencontrado_colaborativo1"));
							ps.println("<br><b>");
							ps.println("<br><b>");
							ps.println(Configuracion.messages.getString("noencontrado_colaborativo2"));
							ps.println("</font><br>");
						}
						
						ps.println("</td></tr></table></body></html>");
						
						//Cerramos punteros
						 stmt.close();
						 ps.close();
						 res.close();
							
					}catch (SQLException e) {						
						 System.out.println("Error Conectando a la Base de Datos");					
					}finally{						
					}
					 
		    } catch (IOException e) {      
		    	System.out.println("Error Creando La Traduccion");
			} 
			

		return fichero;
	}
	
	public int getNumeroPalabras(){
		return numeroPalabras-1;
	}

}