/* CoolTran, traductor de trminos.
 * 
 * Copyright (C) 2007
 *
 * Authors: Javier Garca Palacios <jgarcia1709@gmail.com>
 *          Diego Sevillano de Miguel <sevas85@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
 */

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Locale;
import java.util.Properties;
import java.util.ResourceBundle;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;

import java.io.IOException;
//import java.net.URL;



public class Configuracion {
	
	String[] idioma = {"Espaol","English","Deutsch","Franaise","Portugus"};
	String combiTeclas = "Ctrl,cIzq";
	String[] dicc_install = null;
	ArrayList<String> colab_install = null;
	ArrayList<String> colab_tabla = null;
	//String[] tipo_diccionario = {"Local","Colaborativo"};
	String[] valoracion = {"Bien","Regular","Mal"};
    static ResourceBundle messages;
    Locale currentLocale = null;
    static Properties propiedades = null;
    static Cooltranpro traduc = null;
    //String CONFIGURATION_FILE = "config/Configuracion.properties";
    String fileName = null;
    public String path = "";
    
    

	public Configuracion () { //carga la configuracion de la aplicacion del fichero
		

		//path = System.getProperty("java.class.path");
		//System.out.println(path);
		//int pathFin = path.indexOf(":");
		//System.out.println(pathFin);
		//if (pathFin != -1){
		//	path = path.substring(0,pathFin);
		//}else{
		//	System.out.println("ejecucion externa");
			//path = path.substring(0, path.length()-15);
		//}
		/*path = 	this.getClass().getClassLoader().getResource("config").toString();
		System.out.println("Este Si");
		path = path.substring(0, path.length()-6);
		path = path.substring(5, path.length());
		System.out.println(path);
		*/
		//path="/root/proyecto/csl-colltran/Implementation/cooltran/";
			
		
		//System.out.println(path);
    
	     fileName="config/Configuracion.properties";  
	    // System.out.println(fileName);
		 FileInputStream f;
		
	
		

		try {
			
			f =  new FileInputStream(fileName);
			propiedades = new Properties();
			propiedades.load(f);
			f.close();
			
		} catch (IOException e) {
			System.out.println("ERROR CARGANDO EL FICHERO CONFIGURACION");
		}			
	
		Locale []  LocalesSoportados = {
			    new Locale("es","ES"),
			    new Locale("en","EN"),
			    new Locale("de","DE"),
			    new Locale("fr","FR"),
			    new Locale("pt","PT")
		};
		
		currentLocale = LocalesSoportados[Integer.valueOf(propiedades.getProperty("idiDefault"))];	
		messages = ResourceBundle.getBundle("lang/MessagesBundle",currentLocale);
		
		//por defecto -1 carga el de configuracion
		cambiarDiccionario("-1");
		
	}//configuracion
	
	
	public  void guardarconfiguracion(){ //guarda la configuracion de la aplicacion al fichero
		
		FileOutputStream out;
		try {
			out = new FileOutputStream(fileName);
			propiedades.store(out, "---Grabacion de Configuracin---");
			out.close();
			
		} catch (FileNotFoundException e) {
			System.out.println("ERROR BUSCANDO EL FICHERO");		
		} catch (IOException e) {
			System.out.println("ERROR GUARDANDO EL FICHERO");	
		}
		
	}//guardarConfiguracion
	
	public void cambiaridioma (String idioma){
		Locale []  LocalesSoportados = {
				 new Locale("es","ES"),
				 new Locale("en","EN"),
				 new Locale("de","DE"),
				 new Locale("fr","FR"),
				 new Locale("pt","PT")
		};
		
		currentLocale = LocalesSoportados[Integer.valueOf(idioma)];	
		messages = ResourceBundle.getBundle("lang/MessagesBundle",currentLocale);
		propiedades.setProperty("idiDefault", idioma);
		guardarconfiguracion();

	}//cambiaridioma
	
	
	public void cambiarDiccionario(String diccionario) {
		
		FileInputStream f = null;
	//	FileInputStream dicSoportados[] = null;
		
		if (!diccionario.equals("-1")){
			propiedades.setProperty("dicLocDefault", diccionario);
			guardarconfiguracion();
		}
		
		localizarDiccionarios(); //busca diccionarios sistema
		
		try{
	/*		dicSoportados = new FileInputStream[dicc_install.length];
			for (int i=0;i<dicc_install.length;i++){
				dicSoportados[i] = new FileInputStream(dicc_install[i]);	
			}
		
			f = dicSoportados[Integer.valueOf(propiedades.getProperty("dicLocDefault"))];	
	*/
			f=new FileInputStream("diccionarios/"+propiedades.getProperty("dicLocDefault")+".properties");
			traduc = new Cooltranpro();
			traduc.cargar(f);
			
			
			//falta cerrar punteros a ficheros
		
		}catch(IOException e){	
			System.out.println("HEMOS CAMBIADO EL TRADUCTOR");
		}
	
	}//cambiarDiccionario
	
	
	
	public void localizarDiccionarios( ) {
		
		File fichero=new File("diccionarios");
		
		String[] listaArchivos=fichero.list();
		int nDic = 0;
		int cont = 0;
		
		//contamos el numero de diccionario correctos
		for(int i=0; i<listaArchivos.length; i++){
			if (listaArchivos[i].endsWith(".properties")) {
				nDic++;
			}
		}
		
		dicc_install = new String[nDic];
		
		for(int i=0; i<listaArchivos.length; i++){
			if (listaArchivos[i].endsWith(".properties")) {
				dicc_install[cont]="diccionarios/"  + listaArchivos[i];
				//System.out.println(dicc_install[cont]);
				cont++;
			}
		}

	}//localizarDiccionarios
	
	
	public void cargarColaborativo(Conexion conexion){
			
		Connection con = null;
		String query = "";
		Statement stmt = null; 
		ResultSet res = null;

		try{
		
		con = conexion.con;
		query ="select nombre,tabla from colaborativos";
	
		stmt =(Statement) con.createStatement();	
		res = (ResultSet) stmt.executeQuery(query);
			
		colab_install = new ArrayList<String>();
		colab_tabla = new ArrayList<String>();
			
		while (res.next()){		
			colab_install.add(res.getString(1));
			colab_tabla.add(res.getString(2));		
		}
						
		} catch (SQLException e) {
			System.out.println("Error consultando los diccionarios colaborativos");
			e.printStackTrace();
		}

	}//cargarColaborativo

	public void cambiaTipoDic(String tipo){
		propiedades.setProperty("tipoDic", tipo);
		guardarconfiguracion();
	}//cambiaTipoDic
	
	
	public void cambiaDicColab(String tipo){
		propiedades.setProperty("dicColDefault", tipo);
		guardarconfiguracion();
	}//cambiaTipoDic
	
	public void cambiaIndiceColab(String indice){
		propiedades.setProperty("indiceColaborativo", indice);
		guardarconfiguracion();
	}//cambiaIndiceDic
	
	public void cambiaConexion(String conexion){
		propiedades.setProperty("dispConexion", conexion);
		guardarconfiguracion();
	}//cambiaConexion
	
	public void cambiaTeclas(String tecla, String estado){
		propiedades.setProperty(tecla, estado);
		guardarconfiguracion();
	}//cambiaTeclas
	
	public void cambiaSplash(String splash){
		propiedades.setProperty("splash", splash);
		guardarconfiguracion();
	}//cambiaSplash
	
	public String getCombiTeclas(){
		return(combiTeclas);
	}
	
	
} 


